_TITLE "Snowjob, a B+ mod" 'from Mike's mod of Peter W, to QB64 copied and B+ mod 2018-12-5
' Cyber font.bmp from Cybermonkey at Walter's forum RIP
' 2018-12-05 repost with better math

CONST XMAX = 800
CONST YMAX = 600

' background pick an image
wallpaper& = _LOADIMAGE("xmas.bmp", 32)
wallpaper& = _LOADIMAGE("xmas1.jpg", 32)
'wallpaper& = _LOADIMAGE("snow1.jpg", 32)

'flake
snowflake& = _LOADIMAGE("snowflake.gif", 32)
FOR i = 0 TO 50
    _CLEARCOLOR _RGB32(i, i, i), snowflake&
NEXT

'cyber font
DIM SHARED cf&, cfW, cfH
cf& = _LOADIMAGE("Cyber font.bmp", 32)
cfW = 40
cfH = 34

'snow making machine
TYPE PARTICLE
    x AS SINGLE
    y AS SINGLE
    size AS SINGLE
    speed AS SINGLE
    angle AS SINGLE
    maxy AS SINGLE
END TYPE
nLayers = 11
flakes = 2 ^ (nLayers + 1) - 1
DIM snow(flakes) AS PARTICLE

FOR layer = nLayers TO 0 STEP -1
    FOR flake = 0 TO 2 ^ layer
        snow(flake).x = RND * XMAX
        snow(flake).y = RND * YMAX - YMAX
        snow(flake).size = nLayers - layer
        snow(flake).speed = .1 * (nLayers - layer)
        snow(flake).angle = RND * (_PI - _PI(1 / 6)) + _PI(1 / 12)
        snow(flake).maxy = .5 * YMAX + (nLayers - layer) * (.5 * YMAX / nLayers)
    NEXT
NEXT

SCREEN _NEWIMAGE(XMAX, YMAX, 32)
_SCREENMOVE 200, 100
DO
    _PUTIMAGE , wallpaper&, 0
    FOR flake = flakes TO 0 STEP -1
        snow(flake).x = snow(flake).x + COS(snow(flake).angle) * snow(flake).speed + RND * 2 - .75
        snow(flake).y = snow(flake).y + SIN(snow(flake).angle) * snow(flake).speed + RND * 2 - .5
        _PUTIMAGE (snow(flake).x, snow(flake).y)-STEP(snow(flake).size, snow(flake).size), snowflake&, 0

        IF snow(flake).y > snow(flake).maxy THEN
            snow(flake).x = RND * XMAX: snow(flake).y = RND * YMAX - 1.1 * YMAX
        END IF
        IF snow(flake).x < 0 THEN
            snow(flake).x = XMAX
        ELSEIF snow(flake).x > XMAX THEN
            snow(flake).x = 0
        END IF
    NEXT
    'LINE (180, YMAX - 65)-STEP(420, 50), _RGBA32(128, 0, 0, 180), BF
    cfMessage "MERRY CHRISTMAS!", 200, YMAX - 60, 400, 40 'Cybermonkey's font
    _DISPLAY
    _LIMIT 60
LOOP

SUB cfMessage (message$, xBox, yBox, wBox, hBox)
    lm = LEN(message$)
    bm = .125 * hBox
    px = lm * (cfW + bm) + 2 * bm
    py = cfH + 2 * bm
    xScale = wBox / px
    yScale = hBox / py
    FOR i = 1 TO LEN(message$)
        c$ = MID$(message$, i, 1)
        cfLetter c$, xBox + (i - 1) * (cfW + bm) * xScale + bm, yBox + bm, xScale, yScale
    NEXT
END SUB

SUB cfLetter (L$, x, y, xScale, yScale)
    _CLEARCOLOR _RGB32(0, 0, 0), cf&
    lNum = INSTR("ABCDEFGHIJKLMNOPQRSTUVWXYZ!'()-.?:0123456789, ", UCASE$(L$))
    IF lNum = 0 THEN EXIT SUB ' couldn't find it
    lNum = lNum - 1
    lRow = lNum \ 8 '5 + rows
    lCol = lNum MOD 8 '8 chars per row
    lW = 40
    lH = 34
    _PUTIMAGE (x, y)-STEP(lW * xScale, lH * yScale), cf&, 0, (lCol * lW, lRow * lH)-STEP(lW - 1, lH - 1)
END SUB

